.. _installation-development-hybrid:

Hybrid installation
===================

This way of installation is almost identical to the :ref:`manual installation
<installation-development-manual>`, so please refer to that chapter first. The
only difference is that some of the dependent services, namely PostgreSQL,
Elasticsearch and Redis, are run via Docker containers and do not need to be
installed separately.

Installing the dependencies
---------------------------

The only additional dependency that is needed for this type of installation is
`Docker <https://www.docker.com/>`__. For this step, please refer to the
:ref:`installation via Docker <installation-development-docker>`. The step to
install Docker Compose can be skipped, as it will not be needed.

Running the services
--------------------

PostgreSQL can be run via the following command, which will export port 5432 of
the container and persist all data in a named volume called ``postgres``:

.. code-block:: bash

  docker run --name postgres -d -p 5432:5432 -v postgres:/var/lib/postgresql/data -e POSTGRES_DB=kadi -e POSTGRES_USER=kadi -e POSTGRES_PASSWORD=kadi postgres:11

Elasticsearch can be run via the following command, which will export port 9200
of the container and persist all data in a named volume called
``elasticsearch``:

.. code-block:: bash

  docker run --name elasticsearch -d -p 9200:9200 -v elasticsearch:/usr/share/elasticsearch/data -e discovery.type=single-node -e "ES_JAVA_OPTS=-Xms512m -Xmx512m" elasticsearch:7.9.1

Redis can be run via the following command, which will export port 6379 of the
container and persist all data in a named volume called ``redis``:

.. code-block:: bash

  docker run --name redis -d -p 6379:6379 -v redis:/data redis:5

For more information about managing the containers, please refer to the
official documentation of `Docker <https://docs.docker.com/>`__.
